%define name	mercurial-server
%define version	1.2
%define release %mkrel 6
%define subrel 3

Summary:	Mercurial authentication and authorization tools
Name:		%{name}
Version:	%{version}
Release:	%{release}
Source0:	http://dev.lshift.net/paul/%{name}/%{name}_%{version}.tar.gz
License:	GPLv2
Group:		Development/Other
Url:		http://www.lshift.net/mercurial-server.html
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch:	noarch
Requires:	mercurial, openssh-server
Requires(postun): /usr/sbin/userdel
Requires(pre):  /usr/sbin/groupadd
Requires(pre):  /usr/sbin/useradd
BuildRequires:	xsltproc, docbook-style-xsl

%description
mercurial-server gives your developers remote read/write access to centralized
Mercurial repositories using SSH public key authentication; it provides
convenient and fine-grained key management and access control. 

%prep
%setup -q -n %{name}_%{version}.orig

%install
%__install -d -m 755 %{buildroot}%{_sysconfdir}/mercurial-server/keys/root
%__install -d -m 755 %{buildroot}%{_sysconfdir}/mercurial-server/keys/users
%__install -m 644 src/init/conf/access.conf %{buildroot}%{_sysconfdir}/mercurial-server/

%__install -d -m 755 %{buildroot}%{_sysconfdir}/remote-hgrc.d
%__install -m 644 src/init/conf/remote-hgrc.d/* %{buildroot}%{_sysconfdir}/remote-hgrc.d

PYTHONDONTWRITEBYTECODE= %__python setup.py install --root=%{buildroot} --install-scripts=%{_datadir}/%{name} --install-data=%{_datadir}/%{name} 

%__install -m 755 -d %{buildroot}/%{_localstatedir}/hg

pushd doc
xsltproc --nonet -o ../manual.html /usr/share/sgml/docbook/xsl-stylesheets/html/docbook.xsl manual.docbook
popd

%pre
getent group hg || /usr/sbin/groupadd -r hg 
getent passwd hg >/dev/null || /usr/sbin/useradd -d /var/hg -g hg -s /bin/bash -r hg 

%post
# .mercurial-server needs to be in the hg user directory:
[ ! -e ~hg/.mercurial-server ] && /usr/bin/su hg -s /bin/bash -c "install -m 600 /usr/share/mercurial-server/init/dot-mercurial-server ~hg/.mercurial-server" 

[ -d /var/hg ] && [ ! -d /var/hg/repos ] && \
chown -R hg:hg /var/hg && \
/bin/su -s /bin/bash hg -c "/usr/share/mercurial-server/init/hginit /usr/share/mercurial-server" 

cat <<EOF
-------------------------------------------------------------------------------
Place the SSH public key(s) of the user(s) who require access to the repository
in the directory /etc/mercurial-server/keys/root and run 
/usr/share/mercurial-server/refresh-auth while logged in as the user hg.
-------------------------------------------------------------------------------
EOF

%postun
if [ $1 -eq 0 ] ; then
/usr/sbin/userdel hg > /dev/null || true
[ -d /var/hg ] && rm -rf /var/hg
fi

%files 
%defattr(-,root,root)
%doc CREDITS LICENSE NEWS README manual.html
%dir %{_sysconfdir}/mercurial-server
%config(noreplace) %{_sysconfdir}/mercurial-server/keys/ 
%config(noreplace) %{_sysconfdir}/mercurial-server/access.conf
%{_sysconfdir}/remote-hgrc.d/access.rc
%{_sysconfdir}/remote-hgrc.d/logging.rc
%dir %attr(-,hg,hg) %{_localstatedir}/hg
%{_datadir}/mercurial-server/
%{python_sitelib}/*egg-info
%{python_sitelib}/mercurialserver



%changelog
* Tue Jun 18 2013 philippem <philippem> 1.2-6.3.mga2
+ Revision: 444740
- fix postun
- add Requires to manage user hg
- Fix warning and error at install (#3770)

  + lebedov <lebedov>
    - Move installation of dot-mercurial-server from pre to post install.

* Wed Apr 18 2012 lebedov <lebedov> 1.2-3.mga2
+ Revision: 231453
- Fix path to dot-mercurial-server (#3770)

* Thu Mar 15 2012 lebedov <lebedov> 1.2-2.mga2
+ Revision: 223457
- Correct path to su (#3770).

* Wed Sep 28 2011 lebedov <lebedov> 1.2-1.mga2
+ Revision: 149682
- Update to 1.2.

* Tue Mar 08 2011 ennael <ennael> 0.6-2.mga1
+ Revision: 66497
- imported package mercurial-server

